define susefirewall2::custom
(
	$source,
	$type = 'tcp',
	$destport = undef,
	$srcport = undef
) {

	# Source can contain a mask, as well. Split that off.
	$parts = split($source, '/')
	$addr = $parts[0]
	$mask = $parts[1]

	# Validate the inputs
	validate_re( $addr, '^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$' )
	if ( $mask ) {
		validate_re( $mask, '^\d+$|^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$' )
	}
	validate_re( $type, '^tcp$|^udp$' )
	validate_string( $srcport )
	validate_string( $destport )

	#$output = join( [$source,$type,$destport,$srcport], ',' )
	if ( $destport and $srcport ) {
		$output = join( [$source,$type,$destport,$srcport], ',' )
	}
	elsif ( $destport ) {
		$output = join( [$source,$type,$destport], ',' )
	}
	elsif ( $srcport ) {
		$output = join( [$source,$type,'',$srcport], ',' )
	}


	concat::fragment{ "susefirewall2_custom_$name":
		target	=> $susefirewall2::params::configDestPath,
		order	=> 17,
		content	=> "$output\n",
	}
}
