# == Class: susefirewall2
#
# Full description of class susefirewall2 here.
#
# === Parameters
#
# Document parameters here.
#
# [*sample_parameter*]
#   Explanation of what this parameter affects and what it defaults to.
#   e.g. "Specify one or more upstream ntp servers as an array."
#
# === Variables
#
# Here you should define a list of variables that this module would require.
#
# [*sample_variable*]
#   Explanation of how this variable affects the funtion of this class and if it
#   has a default. e.g. "The parameter enc_ntp_servers must be set by the
#   External Node Classifier as a comma separated list of hostnames." (Note,
#   global variables should not be used in preference to class parameters  as of
#   Puppet 2.6.)
#
# === Examples
#
#  class { susefirewall2:
#    servers => [ 'pool.ntp.org', 'ntp.local.company.com' ]
#  }
#
# === Authors
#
# Author Name <author@domain.com>
#
# === Copyright
#
# Copyright 2014 Your name here, unless otherwise noted.
#
class susefirewall2
{
	include susefirewall2::params

	# Set up the concat instance that we're going to build the config in
	$fwconfig = $params::configDestPath
	concat { $fwconfig:
		owner	=> 'root',
		group	=> 'root',
		mode	=> '0644',
		notify	=> Service[ $params::serviceName ],
	}

	# The pre-defined pieces
	concat::fragment{ 'piece_one':
		target	=> $fwconfig,
		order	=> 01,
		source	=> "puppet:///modules/susefirewall2/etc/sysconfig/SuSEfirewall2.f1"
	}
	concat::fragment{ 'piece_two':
		target	=> $fwconfig,
		order	=> 05,
		source	=> "puppet:///modules/susefirewall2/etc/sysconfig/SuSEfirewall2.f2"
	}
	concat::fragment{ 'piece_three':
		target	=> $fwconfig,
		order	=> 10,
		source	=> "puppet:///modules/susefirewall2/etc/sysconfig/SuSEfirewall2.f3"
	}
	concat::fragment{ 'piece_four':
		target	=> $fwconfig,
		order	=> 15,
		source	=> "puppet:///modules/susefirewall2/etc/sysconfig/SuSEfirewall2.f4"
	}
	concat::fragment{ 'piece_five':
		target	=> $fwconfig,
		order	=> 20,
		source	=> "puppet:///modules/susefirewall2/etc/sysconfig/SuSEfirewall2.f5"
	}


	# Define these less-used things for now
#	concat::fragment{ 'services_ext_tcp':
#		target	=> $fwconfig,
#		order	=> 02,
#		content	=> "FW_SERVICES_EXT_TCP=\"ssh\"\n"
#	}
#	concat::fragment{ 'services_ext_udp':
#		target	=> $fwconfig,
#		order	=> 07,
#		content	=> "FW_SERVICES_EXT_UDP=\"\"\n"
#	}
#	concat::fragment{ 'fw_configurations_ext':
#		target	=> $fwconfig,
#		order	=> 12,
#		content	=> "FW_CONFIGURATIONS_EXT=\"mysql\"\n"
#	}

	# Make sure the latest version of the package is installed
	package	{ "${params::packageName}":
		ensure	=> latest,
		before	=> Concat[ $fwconfig ],
	}

	# Make sure the service is installed and set to be running
	service { "${params::serviceName}":
		ensure		=> running,
		enable		=> true,
		subscribe	=> Concat[ $fwconfig ],
	}
}
